from collections import namedtuple

Company = namedtuple('Company', 'id, url, media_id, type_id, region_id, name')

Entity = namedtuple('Entity', 'id, name, country')


class CompanyMaker:
    def __init__(self, companies=None):
        self.in_site = list()
        if companies:
            for i in companies:
                self.in_site.append(Entity(i[0], i[1], i[2]))
        self.companies = list()

    def make_companies(self, media):
        if media == 'mhn':
            self._make_list_for_mhn()
        elif media == 'tc':
            self._make_list_for_tc()
        elif media == 'aitop':
            self._make_list_for_aitop()
        elif media == 'cb':
            self._make_list_for_cb()
        elif media == 'nana':
            self._make_list_for_nanalyze()

    def get_companies(self):
        return self.companies

    def _make_list_for_mhn(self):
        for i in self.in_site:
            tag = i.name
            if tag.find(' '):
                tag = tag.replace(' ', '-')
            if tag.find('.'):
                tag = tag.replace('.', '')
            self.companies.append(Company(i.id, 'http://www.mobihealthnews.com/tag/' + tag, 43, 2, 2, i.name))

    def _make_list_for_tc(self):
        for i in self.in_site:
            tag = i.name
            if tag.find(' '):
                tag = tag.replace(' ', '-')
            if tag.find('.'):
                tag = tag.replace('.', '-')
            self.companies.append(Company(i.id, 'https://techcrunch.com/tag/' + tag, 81, 2, 2, i.name))

    def _make_list_for_aitop(self):
        for i in self.in_site:
            self.companies.append(Company(i.id, 'https://aitopics.org/search?view=&filters=&sort=score+desc&q=' + i.name,
                                          129, 2, 2, i.name))

    def _make_list_for_cb(self):
        for i in self.in_site:
            name = i.name.replace(' ', '-').replace('.', '-')
            self.companies.append(Company(i.id, 'http://www.crunchbase.com/organization/{}/press?page=1'.format(name),
                                          None, 2, 2, i.name))

    def _make_list_for_nanalyze(self):
        for i in self.in_site:
            self.companies.append(Company(i.id, 'http://www.nanalyze.com/tag/{}'.format(i.name.lower()),
                                          47, 2, 2, i.name))